(* Copyright 2009, Thant Tessman. Permission is granted for
   non-commercial use provided this copyright notice is preserved. All
   other rights reserved. *)

fun dump text = TextIO.output(TextIO.stdOut, text)

(* {data, dltype, flatten} *)

fun getArgs (df :: rest) =
    let
      fun doit ({data, 
                 dltype : string option, 
                 flatten : string option}, flag :: arg :: rest) =
          (case flag of
             "-t" => SOME {data = data, dltype = SOME arg, flatten = flatten}
           | "-f" => SOME {data = data, dltype = dltype, flatten = SOME arg}
           | _ => NONE)
        | doit (_, _ :: []) = NONE
        | doit (args, []) = SOME args
    in
      doit ({data = df, dltype = NONE, flatten = NONE}, rest)
    end
  | getArgs ([]) = NONE




val _ = case getArgs (CommandLine.arguments ()) of
	  SOME {data, dltype, flatten} => checkFile (data,
                                                     dltype,
                                                     flatten)
	| _ => dump "usage: dlcheck <data-file> [-t <type-file>] [-f <flatten-out-file>]\n"

