(* Copyright 2009, Thant Tessman. Permission is granted for
   non-commercial use provided this copyright notice is preserved. All
   other rights reserved. *)

structure ParsePath =
struct

structure GrammarLrVals = PathGrammarLrValsFun(structure Token = LrParser.Token)

structure Lexer = PathLexerFun(structure Tokens = GrammarLrVals.Tokens)

structure Parser = 
  Join(structure ParserData = GrammarLrVals.ParserData
       structure Lex = Lexer
       structure LrParser=LrParser)

fun parse s =
    let
	val text = ref (s :: [])
	val reader : int -> string = 
	    fn _ => case !text of
			[] => ""
		      | first :: rest => (text := rest; first)
	val lexer = Parser.makeLexer reader
	fun printError (s, _, _) =
	    TextIO.output(TextIO.stdErr,
			  "parsePath: " ^ s ^ "\n")
	    val (result, _) = Parser.parse(0,lexer,printError,())
    in
	result
    end

end
