(* Copyright 2009, Thant Tessman. Permission is granted for
   non-commercial use provided this copyright notice is preserved. All
   other rights reserved. *)

structure Tokens = Tokens

type pos = unit
type svalue = Tokens.svalue
type ('a,'b) token = ('a,'b) Tokens.token
type lexresult = (svalue,pos) token

val eof = fn () => Tokens.EOP((),())

val error = fn e => TextIO.output(TextIO.stdErr, 
				  "path: " ^ e ^ "\n")

%%

%header (functor PathLexerFun(structure Tokens: PathGrammar_TOKENS));

alpha = [a-zA-Z_];
digit = [0-9];
id = {alpha}({alpha}|{digit})*;
nat = {digit}+;

%%

"$"	=> (Tokens.HEAD((), ()));
{id}	=> (Tokens.IDENT(yytext, (), ()));
{nat}	=> (Tokens.NAT(valOf (Int.fromString yytext), (), ()));
"["	=> (Tokens.LEFT_SQUARE((), ()));
"]"	=> (Tokens.RIGHT_SQUARE((), ()));
"."	=> (Tokens.DOT((), ()));
